<template>
  <div>
    <div id="profile-page">
      <div class="profile-header">
        <div class="relative">
          <div class="cover-container rounded-t-lg">
            <img
              class="w-full"
              src="https://pbs.twimg.com/media/DQlOsZyVAAAXfAx.jpg"
              alt="profile_banner"
            />
          </div>
          <div class="profile-img-container pointer-events-none">
            <div>
              <vs-avatar
                class="user-profile-img"
                :src="user.image"
                size="85px"
              />
            </div>
            <div class="profile-actions pointer-events-auto flex">
              <vs-button
                icon-pack="feather"
                @click="$router.push({name:'user-settings'}).catch(() => {})"
                radius
                icon="icon-edit-2"
              ></vs-button>
              <vs-button
                icon-pack="feather"
                radius
                icon="icon-settings"
                class="ml-2 lg:ml-4"
              ></vs-button>
            </div>
          </div>
        </div>
        <div
          class="flex items-center justify-end flex-wrap profile-header-nav p-6"
        >
          <div class="block sm:hidden">
            <feather-icon
              @click="isNavOpen = !isNavOpen"
              icon="AlignJustifyIcon"
              v-show="!isNavOpen"
              class="vx-navbar-toggler cursor-pointer"
            />
            <feather-icon
              icon="XIcon"
              v-show="isNavOpen"
              @click="isNavOpen = !isNavOpen"
              class="vx-navbar-toggler cursor-pointer"
            />
          </div>
          <div
            :class="isNavOpen ? 'block' : 'hidden'"
            class="w-full flex-grow sm:flex sm:items-center sm:w-auto"
          >
            <div class="text-sm sm:flex-grow">
              <ul
                class="sm:flex justify-around mt-8 w-full md:mt-0 md:ml-auto md:w-3/4"
              >
                <li class="p-2 sm:p-0">
                  <router-link to="/pages/profile">Timeline</router-link>
                </li>
                <li class="p-2 sm:p-0">
                  <router-link to="/pages/profile">About</router-link>
                </li>
                <li class="p-2 sm:p-0">
                  <router-link to="/pages/profile">Photos</router-link>
                </li>
                <li class="p-2 sm:p-0">
                  <router-link to="/pages/profile">Friends</router-link>
                </li>
                <li class="p-2 sm:p-0">
                  <router-link to="/pages/profile">Videos</router-link>
                </li>
                <li class="p-2 sm:p-0">
                  <router-link to="/pages/profile">Events</router-link>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="vx-row mt-5" v-if="user_posts">
      <vx-card
        class="mt-base mt-5"
        v-for="(post, index) in user_posts"
        :key="index"
      >
        <div class="post-header flex justify-between mb-4">
          <div class="flex items-center">
            <div>
              <vs-avatar
                class="m-0"
                :src="user.image"
                size="45px"
              ></vs-avatar>
            </div>
            <div class="ml-4">
              <h6>{{ user.name }}</h6>
              <small
                >{{ post.created_at | moment("dddd, MMMM Do YYYY") }} at
                {{ post.created_at | moment("h:m:s a") }}</small
              >
            </div>
          </div>
          <div class="flex">
            <feather-icon
              class="ml-4"
              icon="HeartIcon"
              :svgClasses="{
                'text-danger fill-current stroke-current': checkIfLiked(
                  post.post_likes
                )
              }"
            ></feather-icon>
          </div>
        </div>
        <div v-if="post.image">
          <div class="post-content">
            <p>{{ post.content }}</p>
          </div>
          <div class="post-media-container mb-6 mt-4">
            <ul class="flex post-media-list">
              <li class="post-media m-1 w-full">
                <img
                  class="responsive rounded"
                  :src="post.image"
                  alt="user-upload"
                />
              </li>
            </ul>
          </div>
        </div>
        <div v-else>
          <div class="post-content mb-3">
            <p>{{ post.content }}</p>
          </div>
        </div>

        <div>
          <div class="flex justify-between">
            <div class="flex items-center">
              <div class="flex items-center">
                <feather-icon
                  class="mr-2"
                  icon="HeartIcon"
                  svgClasses="h-5 w-5"
                ></feather-icon>
                <span>{{ post.likes }}</span>
              </div>
              <ul class="users-liked user-list ml-3 sm:ml-6 mt-3">
                <li v-for="(post_like, index) in post.post_likes" :key="index">
                  <vx-tooltip :text="user.name" position="bottom">
                    <vs-avatar
                      :src="user.image"
                      size="30px"
                      class="border-2 border-white border-solid -m-1"
                    ></vs-avatar>
                  </vx-tooltip>
                </li>
              </ul>
              <small v-if="post.likes > 6" class="ml-2"
                >+{{ post.likes - 5 }} more</small
              >
            </div>
            <div class="flex items-center">
              <feather-icon
                class="mr-2"
                icon="MessageSquareIcon"
                svgClasses="h-5 w-5"
              ></feather-icon>
              <span>{{ post.comments.length }}</span>
            </div>
          </div>
          <div class="comments-container mt-4">
            <ul class="user-comments-list">
              <li
                v-for="(comment, index) in post.comments.slice(0, 3)"
                :key="index"
                class="commented-user flex items-center mb-4"
              >
                <div class="mr-3">
                  <vs-avatar
                    class="m-0"
                    :src="comment.user.image"
                    size="30px"
                  />
                </div>
                <div class="leading-tight">
                  <p class="font-medium">{{ comment.user.name }}</p>
                  <span class="text-xs">{{ comment.content }}</span>
                </div>
                <div class="ml-auto">
                  <div class="flex">
                    <feather-icon
                      icon="HeartIcon"
                      svgClasses="h-4 w-4"
                      class="mr-2 cursor-pointer"
                    ></feather-icon>
                    <feather-icon
                      icon="MessageSquareIcon"
                      svgClasses="h-4 w-4"
                      class="cursor-pointer"
                    ></feather-icon>
                  </div>
                </div>
              </li>
            </ul>
            <span class="flex justify-end" v-if="post.comments.length > 3">
              <a class="inline-flex items-center text-sm" href=""
                ><span>View All</span>
                <feather-icon
                  :icon="$vs.rtl ? 'ChevronsLeftIcon' : 'ChevronsRightIcon'"
                  svgClasses="h-4 w-4"
                ></feather-icon
              ></a>
            </span>
          </div>
          <div class="post-comment">
            <vs-textarea
              label="Add Comment"
              class="mb-2"
              v-model="post.commentbox"
            />
            <vs-button size="small">Post Comment</vs-button>
          </div>
        </div>
      </vx-card>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";

export default {
  data() {
    return {
      isNavOpen: false
    };
  },
  computed: {
    ...mapActions({
      fetchUserPosts: "post/getUserPosts"
    }),

    ...mapGetters({
      user_posts: "post/user_posts",
      success_message: "post/message",
      user: "auth/user"
    })
  },

  mounted() {
    this.fetchUserPosts;
    this.user;
    this.checkIfLiked;
  },

    methods: {
    checkIfLiked(data) {
      data.filter(like => {
        if (like.user_id === this.user.id) return true;
      });

      return null;
    }
  }
};
</script>
<style lang="scss">
@import "@/assets/scss/vuexy/pages/profile.scss";
</style>
